 package graaf;
 import java . awt . * ; 


/*******************************
 * Graafi joonistamise klass
*/
 public class GraafiJoonistaja 
  {
  public static boolean tipumrgendid = false; // tipumrgendid vs tipunumbrid
  static Point jooksevAlguspunkt = new Point(100, 100);
  static String fNimi; // graafi faili tisnimi


/***********************************
 * Konstruktor. Loob raami ja joonistab sellesse failist saadava graafi. Tippudes: tipunumbrid. 
 * Kui faili ei leita, siis joonistab kahest isoleeritud tipust koosneva graafi 
 * @param fnimi graafiga seotud fail (tisnimi vi lihtnimi)
*/
 public  GraafiJoonistaja(String fnimi)
 {
        this.fNimi = tisnimeks(fnimi);
        graafEkraanile(fNimi);
 }

/***********************************
 * Konstruktor. Loob raami ja joonistab sellesse failist saadava graafi,  
 * kas tipunumbritega vi tipunimedega. 
 * Kui faili ei leita, siis joonistab kahest isoleeritud tipust koosneva graafi 
 * @param fnimi graafiga seotud fail (tisnimi vi lihtnimi)
 * @param tm kas nidata tipumrgendeid (<code>true</code>), vi tipunumbreid <code>(false)</code>
*/
 public  GraafiJoonistaja(String fnimi, boolean tm)
 {
        tipumrgendid = tm;
        this.fNimi = tisnimeks(fnimi);
        graafEkraanile(fNimi);
 }


 void graafEkraanile( String fnimi )
 {
         // Antud: graafi faili (tabeli) tisnimi
         // teha pearaam r:
        jooksevAlguspunkt.translate(40,40);
        Raam r = new Raam ( "Graaf" , jooksevAlguspunkt , new Dimension ( 820 , 600 ) ) ;
         // teha pearaami kuular ja lisada pearaamile:
        r . addWindowListener ( new RaamiKuular ( ) ) ;
         // pearaamiga seotud tahvel:
        Tahvel t = new Tahvel ( ) ; // teha tahvel
         // tahvliga seotud vann ja osuti tahvlist vannile:
    try
    {
              t . vann = new Vann (fnimi) ;
    }
    catch (Exception e)
    {
               // faili ei saanud avada (polnud veel)
              System.out.println(e.getMessage());
              t . vann = new Vann () ;
    }
        r.setTitle(fNimi);
         // lisada  tahvel pearaamile:
        r . getContentPane ( ) . add ( t ) ;
        r . setVisible (true ) ; // pearaam ekraanile
 }
 public static String tisnimeks(String fnimi)
 {
         // Antud: faili nimi
         // Tulemus: lisatud jooksva kausta tee (kui oli lihtnimi)
        String er = System.getProperty("file.separator");
        int i = fnimi.indexOf(er);
    if (i != -1)
    {
               // on juba arvatavasti tisnimi
              return fnimi;
    }
    else
    {
              String s = System.getProperty("user.dir");
              return s + er + fnimi;
    }
 }
 }
