 package graaf;
 import graaf.*;
 public class Tipukuhi
  {
   // Tippude kahendkuhi
   // Kuhjaomadus: alluva vti ei ole viksem kui lemuse vti
  Graaf g; // graaf, mille tippudes on mratud vtmevli "d"
  int n; // kuhjas olevate tippude arv
  Tipp[] a; // a[1], a[2], ..., a[n] -- kuhjas olevad tipud
  int[] ind; // ind[j] on graafi j-nda tipu asukoht kuhjas (vi null)
 public Tipukuhi(Graaf g)
 {
         // Konstrueeritakse thi tipukuhi graafi g jaoks
        n = 0;
        a = new Tipp[g.n()+1];
        ind = new int[g.n()];
        this.g = g;
 }
 public boolean onThi()
 {
        return n == 0;
 }
 public void lisada(Tipp v)
 {
         // Antud: tipp v
         // Tulemus: tipp v lisatud sellesse kuhja
        n++;
        a[n] = v;
        ind[g.indeks(v)] = n;
        viia_les(n);
         // _ inspectArray :ind
 }
 public void uuendada(Tipp v)
 {
         // Antud: tipp v
         // Tulemus: kui v on kuhjas,
         // siis kuhi muudetud vastavalt v (uuele) vtmele
        int i = ind[g.indeks(v)];
    if (i != 0)
    {
       if (!viia_les(i))
       {
                    viia_alla(i);
       }
    }
 }
 public Tipp vtta()
 {
         // Tulemus: kuhjast vetakse vhima d vrtusega tipp
         // tagastatakse viit vetud tipule (null, kui kuhi oli thi)
    if (onThi())
    {
              return null;
    }
        Tipp tulem = a[1];
        ind[g.indeks(tulem)] = 0;
        a[1] = a[n];
        ind[g.indeks(a[n])] = 1;
        n--;
        viia_alla(1);
        return tulem;
 }
 private int vasak(int k)
 {
         // Antud: kuhja elemendi indeks k
         // Tulemus: tagastatakse selle elemendi vasaku alluva indeks (vi -1)
        int tulem = 2*k;
    if (tulem > n)
    {
              tulem = -1;
    }
        return tulem;
 }
 private int parem(int k)
 {
         // Antud: kuhja elemendi indeks k
         // Tulemus: tagastatakse selle elemendi parema alluva indeks (vi -1)
        int tulem = 2*k+1;
    if (tulem > n)
    {
              tulem = -1;
    }
        return tulem;
 }
 private int lemus(int k)
 {
         // Antud: kuhja elemendi indeks k
         // Tulemus: tagastatakse selle elemendi lemuse indeks (vi 0)
        int tulem = k/2;
        return tulem;
 }
 private boolean viia_alla(int i)
 {
         // Tulemus: ptud viia  vimalikult alla kuhja element indeksiga i
         // tagastatakse true, kui allaviimine toimus
        boolean tulem = false;
        int j = vasak(i);
    if (j == -1)
    {
              return false;
    }
        int k = parem(i);
    if (k != -1)
    {
       if (vti(k) < vti(j))
       {
                    j = k;
       }
    }
    if (vti(i) > vti(j))
    {
              tulem = true;
              Tipp x = a[i];
              a[i] = a[j];
              a[j] = x;
              ind[g.indeks(a[i])] = i;
              ind[g.indeks(a[j])] = j;
              viia_alla(j);
    }
        return tulem;
 }
 private boolean viia_les(int i)
 {
         // Tulemus: ptud viia vimalikult les kuhja element indeksiga i
         // tagastatakse true, kui lesviimine toimus
        boolean tulem = false;
        int j = lemus(i);
    if (j > 0)
    {
       if (vti(i) < vti(j))
       {
                    tulem = true;
                    Tipp x = a[i];
                    a[i] = a[j];
                    a[j] = x;
                    ind[g.indeks(a[i])] = i;
                    ind[g.indeks(a[j])] = j;
                    viia_les(j);
       }
    }
        return tulem;
 }
 private int vti(int i)
 {
         // Antud: kujja elemendi indeks i
         // Tulemus: tagastatakse selle elemendi (tipu) vti (d)
        return Integer.parseInt( a[i].vli("d"));
 }
 }
